# Copyright 2023- Le Filament (https://le-filament.com)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html)

from odoo import api, models


class ResPartner(models.Model):
    _name = "res.partner"
    _description = "Res partner"
    _inherit = ["res.partner", "sharepoint.mixin"]

    @api.model_create_multi
    def create(self, vals_list):
        partners = super().create(vals_list)
        for partner in partners:
            partner.init_sharepoint_directory()
        return partners

    def action_redirect_to_sharepoint(self):
        # Action de redirection
        return {
            "type": "ir.actions.act_url",
            "url": self.sharepoint_folder_url,
            "target": "new",
        }

    def action_init_sharepoint(self):
        if not self.sharepoint_folder_id:  # and if self is a cooperative
            # le dossier associé n est pas créé lets go
            self.init_sharepoint_directory()

        # Action de redirection
        return {
            "type": "ir.actions.act_url",
            "url": self.sharepoint_folder_url,
            "target": "new",
        }
